﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Newtonsoft.Json;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.Linq;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.IO;
using System.Linq;

namespace ASPNetRazorPageDemo.Pages
{
    public class DemoModel : PageModel
    {
        public static List<Orders> order = new List<Orders>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
        }
        public JsonResult OnPostDataSource([FromBody]DataManager dm)
        {
            if (order.Count == 0)
                BindDataSource();
            IEnumerable data = order;
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                data = operation.PerformSorting(data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                data = operation.PerformWhereFilter(data, dm.Where, dm.Where[0].Operator);
            }
            if (dm.Search != null && dm.Search.Count > 0) //Searching
            {
                data = operation.PerformSearching(data, dm.Search);
            }
            var count = data.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                data = operation.PerformSkip(data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                data = operation.PerformTake(data, dm.Take);
            }
            return new JsonResult(new { result = data, count = count });
        }
        public class Orders
        {
            public Orders()
            {
            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }
            [Range(0, int.MaxValue, ErrorMessage = "OrderID must be greater than 0.")]
            public long OrderID { get; set; }
            [StringLength(5, ErrorMessage = "CustomerID must be 5 characters.")]
            public string CustomerID { get; set; }
            [Range(1, 9, ErrorMessage = "EmployeeID must be between 0 and 9.")]
            public int EmployeeID { get; set; }
            [Display(Name = "Freight column")]
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }

        //public JsonResult OnPostUpdate([FromBody]CRUDModel<Orders> value)
        //{
        //    var ord = value.Value;
        //    Orders val = order.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
        //    val.OrderID = ord.OrderID;
        //    val.EmployeeID = ord.EmployeeID;
        //    val.CustomerID = ord.CustomerID;
        //    val.Freight = ord.Freight;
        //    val.OrderDate = ord.OrderDate;
        //    val.ShipCity = ord.ShipCity;
        //    return new JsonResult(value.Value);
        //}
        ////insert the record
        //public JsonResult OnPostInsert([FromBody]CRUDModel<Orders> value)
        //{
        //    order.Insert(0, value.Value);
        //    return new JsonResult(value);
        //}
        ////Delete the record
        //public JsonResult OnPostDelete(int key)
        //{
        //    //order.Remove(order.Where(or => or.OrderID == int.Parse(deleted.Key.ToString())).FirstOrDefault());
        //    //return new JsonResult(deleted);
        //    return null;
        //}
    }
}